OpenTTD Source: FileList Class Reference

OpenTTD Source 1.11.0-RC1

Public Member Functions | Data Fields
FileList Class Reference

List of file information. More...

`#include <fios.h>`

Inheritance diagram for FileList:

## Public Member Functions
FiosItem * | Append ()
| Construct a new entry in the file list. More...
size_t | Length () const
| Get the number of files in the list. More...
const FiosItem * | Begin () const
| Get a pointer to the first file information. More...
const FiosItem * | End () const
| Get a pointer behind the last file information. More...
const FiosItem * | Get (size_t index) const
| Get a pointer to the indicated file information. More...
FiosItem * | Get (size_t index)
| Get a pointer to the indicated file information. More...
const FiosItem & | operator[] (size_t index) const
FiosItem & | operator[] (size_t index)
| Get a reference to the indicated file information. More...
void | Clear ()
| Remove all items from the list.
void | Compact ()
| Compact the list down to the smallest block size boundary.
void | BuildFileList (AbstractFileType abstract_filetype, SaveLoadOperation fop)
| Construct a file list with the given kind of files, for the stated purpose. More...
const FiosItem * | FindItem (const char *file)
| Find file information of a file by its name from the file list. More...

## Data Fields
std::vector< FiosItem > | files
| The list of files.

## Detailed Description

List of file information.

Definition at line 112 of file fios.h.

## Member Function Documentation

## ◆ Append()

FiosItem* FileList::Append | ( |  | ) |
| inline

Construct a new entry in the file list.

Returns
  Pointer to the new items to be initialized.

Definition at line 120 of file fios.h.

References files.

## ◆ Begin()

const FiosItem* FileList::Begin | ( |  | ) | const
| inline

Get a pointer to the first file information.

Returns
  Address of the first file information.

Definition at line 138 of file fios.h.

References files.

Referenced by End(), FindItem(), and SortSaveGameList().

## ◆ BuildFileList()

void FileList::BuildFileList | ( | AbstractFileType | abstract_filetype,
|  | SaveLoadOperation | fop
| ) |  |

Construct a file list with the given kind of files, for the stated purpose.

Parameters

  abstract_filetype | Kind of files to collect.
  fop | Purpose of the collection, either SLO_LOAD or SLO_SAVE.

Definition at line 76 of file fios.cpp.

References Clear(), FiosGetHeightmapList(), FiosGetSavegameList(), FiosGetScenarioList(), FT_HEIGHTMAP, FT_NONE, FT_SAVEGAME, FT_SCENARIO, SLO_LOAD, and SLO_SAVE.

Referenced by ConsoleFileList::ValidateFileList().

## ◆ End()

const FiosItem* FileList::End | ( |  | ) | const
| inline

Get a pointer behind the last file information.

Returns
  Address behind the last file information.

Definition at line 147 of file fios.h.

References Begin(), and Length().

Referenced by FindItem(), and SortSaveGameList().

## ◆ FindItem()

const FiosItem * FileList::FindItem | ( | const char * | file | ) |

Find file information of a file by its name from the file list.

Parameters

  file | The filename to return information about. Can be the actual name or a numbered entry into the filename list.

Returns
  The information on the file, or `nullptr` if the file is not available.

Definition at line 108 of file fios.cpp.

References Begin(), End(), Get(), IsInsideMM(), and Length().

## ◆ Get() [1/2]

FiosItem* FileList::Get | ( | size_t | index | ) |
| inline

Get a pointer to the indicated file information.

File information must exist.

Returns
  Address of the indicated existing file information.

Definition at line 165 of file fios.h.

References files.

## ◆ Get() [2/2]

const FiosItem* FileList::Get | ( | size_t | index | ) | const
| inline

Get a pointer to the indicated file information.

File information must exist.

Returns
  Address of the indicated existing file information.

Definition at line 156 of file fios.h.

References files.

Referenced by FindItem().

## ◆ Length()

size_t FileList::Length | ( |  | ) | const
| inline

Get the number of files in the list.

Returns
  The number of files stored in the list.

Definition at line 129 of file fios.h.

References files.

Referenced by End(), and FindItem().

## ◆ operator[]()

FiosItem& FileList::operator[] | ( | size_t | index | ) |
| inline

Get a reference to the indicated file information.

File information must exist.

Returns
  The requested file information.

Definition at line 179 of file fios.h.

References files.

The documentation for this class was generated from the following files:

- src/fios.h
- src/fios.cpp